C--COMMON BLOCK INCLUDE FILE FOR HYPOINVERSE PLOT PARAMETERS

C--BOUNDARIES OF MAP AREA & CENTER IN WORLD COORDS (APPROX. INCHES)
	PARAMETER (BN=1.,TN=6.,FN=.36,RN=6.6,WLAT=3.5,WLON=3.48)
C--TEXT POSITIONING CONSTANTS IN WORLD COORDS
	PARAMETER (YT1=6.,TSP=.25,XT1=7.56,XT2=9.)

	CHARACTER LIFIL*30,TITL*56
	LOGICAL LLIN,LSTA,LCLR,LINT,LRTP,LDRW
	DOUBLE PRECISION TJ,TEND,DT

C--MAP PARAMETERS
	COMMON /P/ BLAT		
C!CENTER LAT IN DECIMAL DEGREES -POS N (CTR)
	COMMON /P/ BLON		
C!CENTER LON IN DECIMAL DEGREES -POS E (CTR)
	COMMON /P/ YSC		
C!LAT SCALING FACTOR (DEG TO ")
	COMMON /P/ XSC		
C!LON SCALING FACTOR (DEG TO ")
	COMMON /P/ SCAL		
C!DIMENSIONLESS MAP SCALE (SCL)
	COMMON /P/ NLIN		
C!NUMBER OF LINEAR DATA FILES (LIN)
	COMMON /P/ LICLR (4)	
C!COLOR FOR EACH LINEAR FILE (LIN)
	COMMON /PC/ LIFIL (4)	
C!LINEAR DATA FILENAMES (LIN)
	COMMON /P/ LSTA		
C!TRUE TO PLOT STATIONS (STP)
	COMMON /PC/ TITL	
C!PLOT TITLE (TIT)
C--STATION PLOTTING SYMBOL PARAMETERS
	COMMON /P/ JSSYM	
C!SYMBOL TYPE FOR PLOTTING STATIONS (STP)
	COMMON /P/ SSIZ
C!SYMBOL SIZE FOR PLOTTING STATIONS (STP)
	COMMON /P/ JSCLR	
C!SYMBOL COLOR FOR PLOTTING STATIONS (STP)

C--SYMBOL SIZE DEPENDENCE ON DEPTH
	COMMON /P/ NMAG		
C!NUMBER OF MAGNITUDE INTERVALS IN USE (MAG)
	COMMON /P/ ASIZ (5)	
C!SYMBOL SIZES BY MAGNITUDE (MAG)
	COMMON /P/ ACUT (6)	
C!MIN MAGS FOR EACH SYMBOL (MAG)
	COMMON /P/ MMAG (5)	
C!EVENT COUNT BY MAGNITUDE INTERVAL
	COMMON /P/ MMAGT (5,7)	
C!EVENT COUNT BY MAG & TIME INTERVAL

C--SYMBOL TYPES & SYMBOL COLORS
	COMMON /P/ LCLR		
C!SETS SYMBOL COLOR & TYPE DEPENDENCE: (INT)
C	T FOR COLOR DEP. ON TIME & SYMBOL DEP. ON DEPTH
C	F FOR COLOR DEP. ON DEPTH & SYMBOL DEP. ON TIME
	COMMON /P/ JSYM (7)	
C!SYMBOL TYPES (SYM)
	COMMON /P/ JCLR (7)	
C!SYMBOL COLORS (CLR)
C	COMMON /P/ INTEN (3,0:7)	
C!RGB INTENSITIES OF THE 8 COLORS (HUE)

C--DEPTH INTERVALS FOR SYMBOL CHOICE
	COMMON /P/ NDEP 	
C!NUMBER OF DEPTH INTERVALS IN USE (INT)
	COMMON /P/ ZCUT (8)	
C!MIN DEPTHS FOR EACH SYMBOL (DEP)
	COMMON /P/ MDEP (7)	
C!EVENT COUNT BY DEPTH INTERVAL
	COMMON /P/ MDEPT (7,7)	
C!EVENT COUNT BY DEPTH & TIME INTERVAL

C--BEGINNING DATES & TIMES FOR EACH SYMBOL
	COMMON /P/ NTIM		
C!NUMBER OF TIME INTERVALS IN USE (INT)
	COMMON /P/ MTIM (7)	
C!EVENT COUNT BY TIME INTERVAL
	COMMON /P/ JY(7),JM(7),JD(7),JH(7),JN(7),TJ(7) 
C!(TIM,SET)
	COMMON /P/ ID		
C!LENGTH OF TIME INTERVALS IN DAYS (SET)
	COMMON /P/ IH		
C!LENGTH OF TIME INTERVALS IN HOURS (SET)
	COMMON /P/ DT		
C!LENGTH OF INTERVALS, DECIMAL DAYS (SET)
	COMMON /P/ TEND		
C!ENDING TIME FOR LAST INTERVAL

C--CONTROL PARAMETERS & UNPLOTTED COUNTS
	COMMON /P/ JCFR	
C!FRAME COLOR (FRM)
	COMMON /P/ JCTX		
C!TITLE COLOR (FRM)
	COMMON /P/ LINT	
C!T TO DEFINE INTERVALS FROM FIRST EVENT (RTP)
	COMMON /P/ LRTP		
C!T TO PUT EACH DAYS OUTPUT IN DIFF FILES (RTP)
	COMMON /P/ LNEWL	
C!T TO REDRAW LINES EACH DAY (RTP)
	COMMON /P/ LCOPY	
C!T TO MAKE A SCREEN COPY EACH INTERVAL (RTP)
	COMMON /P/ MXPL		
C!NUMBER OF UNPLOTTED EVENTS
	COMMON /P/ MXPLT (7)	
C!UNPLOTTED EVENTS BY TIME INTERVAL
	COMMON /P/ ERHMAX	
C!ERH CUTOFF FOR PLOTTING (BAD)
	COMMON /P/ ERZMAX	
C!ERZ CUTOFF FOR PLOTTING (BAD)
	COMMON /P/ KODE		
C!HYPLT CONTROL DEPENDING ON PLOT COMMAND
	COMMON /P/ LDRW		
C!FLAG SET TO REDRAW LINES EACH DAY
