      subroutine auto_tr(data,nhead,nfile,filename)
c
c   routine to get trace file names from  a nordic file
c   if file name ends with MNAY, the file contains names of many waveform files,
c   the format is like filenr.lis
c
c   updates
c
c   feb 99 by jh :---------------  verison 7.0 check ------------------
c                 no changes
c   dec 5 2011 jh: add option MANY to exapand files with files
c   apr 30 2012 jh: change MANY to _LIST
c
c   input:
c   data: nordic S-file
c   nhead: number of headers in file
c   output:
c   nfile: number of waveform files
c   filename: waveform files
c
      implicit none
      character*80 data(*)
      character*(*) filename(*)
      character*80 new_file(10,1000)    ! the expanded file names
      character*80 file_out            ! file with full path
      integer nhead,nfile
      integer nlist                    ! number of nlist files
      integer nlist_files(5)           ! number of of files in each LIST file
      integer file_list(200)   ! indicator if a particular file is of LIST type
      integer seiclen
      integer i,k,l

      nfile=0
      do i=2,nhead
         if(data(i)(80:80).eq.'6') then
            nfile=nfile+1
            filename(nfile)(1:78)=data(i)(2:79)
            filename(nfile)(79:80)=' '
          endif
      enddo
cxx      write(6,*)'nfile',nfile
      if(nfile.eq.0) return
c
c   check if any of the files is a file with files indicated
c   by ending with _LIST
c
      nlist=0     ! number of files with files
      do i=1,nfile
        file_list(i)=0
        k=seiclen(filename(i))
        if(filename(i)(k-4:k).eq.'_LIST') then
          file_list(i)=1         ! indicate that this was a LIST file
c
c   check if file exists and where, if not skip
c
          file_out=' '
          call  get_full_wav_name(filename(i),file_out)
          if(file_out.eq.' ') then
              write(6,'(a,a)')' File does not exist ', filename(i)
              write(6,'(a)')  ' File will be skipped'
              goto 200
          endif
c
          nlist=nlist+1
          if(nlist.gt.10) then
             write(6,*) 'Too many LIST files, max 10'
             stop
          endif
          open(96,file=file_out,status='old')
          k=1
 90       continue
          read(96,'(7x,a63)',end=100)new_file(nlist,k)
          if(new_file(nlist,k).eq.' ') goto 100
          k=k+1
          goto 90 
 100      continue
          close(96)
          k=k-1
          nlist_files(nlist)=k
        endif
 200    continue
      enddo

c
c   remove LIST files from list
c
      k=0
      do i=1,nfile
          if(file_list(i).ne.1) then
            k=k+1
            filename(k)=filename(i)
          endif
      enddo           
      if(nlist.gt.0) then
c
c   now put files in list
c     
      l=k
         do k=1,nlist
            do i=1,nlist_files(k)
               l=l+1
               filename(l)=new_file(k,i)
            enddo
         enddo
         nfile=l
      endif
 
      return
      end
